// -*- Mode:C++ -*-
//Header:
//File: SenseBodyInfo.cc
//Title: SenseBody
//Author: NODA, Itsuki
//Date: 2001/03/05
//

//ModifyHistory:
// 2001/03/05: Start to create this file
//EndModifyHistory:

#include "SenseBodyInfo.h"

namespace Soccer {

   //--------------------------------------------------
   // scan server info

   Bool SenseBodyInfo::scan(SimpleSexp & s) {

      UInt len = s.length() ;

      if(len < 3) return False ;

      ///// time
      time.set(s.nth(1)->scanAsInt()) ;

      ///// other
      
      for(SimpleSexp * infolist = s.nthcdr(2) ; infolist->isCons() ; 
	  infolist = infolist->cdr) {
	 SimpleSexp * info = infolist->car ;
	 SimpleSexp * label = info->car ;
	 SimpleSexp * args = info->cdr ;

	 if (label->equal(SC_WORDSTR(ViewMode))) {
	    SimpleSexp *val ;
	    val = args->nth(0) ;
	    if        (val->equal(SC_WORDSTR(High))) { 
	       viewQuality = VQ_high ; 
	    } else if (val->equal(SC_WORDSTR(Low))) { 
	       viewQuality = VQ_low ; 
	    } else {
	       ITK_WRN("illegal view quality: " << *info) ;
	       continue ;
	    }
	    val = args->nth(1) ;
	    if        (val->equal(SC_WORDSTR(Narrow))) { 
	       viewWidth = VW_narrow ; 
	    } else if (val->equal(SC_WORDSTR(Normal))) { 
	       viewWidth = VW_normal ; 
	    } else if (val->equal(SC_WORDSTR(Wide))) { 
	       viewWidth = VW_wide ; 
	    } else {
	       ITK_WRN("illegal view width: " << *info) ;
	       continue ;
	    }
	 } else if (label->equal(SC_WORDSTR(Stamina))) {
	    stamina = args->nth(0)->scanAsFlt() ;
	    effort = args->nth(1)->scanAsFlt() ;
	 } else if (label->equal(SC_WORDSTR(Speed))) {
	    speed = args->nth(0)->scanAsFlt() ;
	 } else if (label->equal(SC_WORDSTR(HeadAngle))) {
	    headAngle = normalizeAngle(args->nth(0)->scanAsFlt()) ;

	 } else if (label->equal(SC_WORDSTR(Move))) {
	    countMove = args->nth(0)->scanAsInt() ;

	 } else if (label->equal(SC_WORDSTR(Turn))) {
	    countTurn = args->nth(0)->scanAsInt() ;
	 } else if (label->equal(SC_WORDSTR(Dash))) {
	    countDash = args->nth(0)->scanAsInt() ;
	 } else if (label->equal(SC_WORDSTR(Kick))) {
	    countKick = args->nth(0)->scanAsInt() ;
	 } else if (label->equal(SC_WORDSTR(Catch))) {
	    countCatch = args->nth(0)->scanAsInt() ;

	 } else if (label->equal(SC_WORDSTR(Say))) {
	    countSay = args->nth(0)->scanAsInt() ;
	 } else if (label->equal(SC_WORDSTR(TurnNeck))) {
	    countTurnNeck = args->nth(0)->scanAsInt() ;
	 } else if (label->equal(SC_WORDSTR(ChangeView))) {
	    countChangeView = args->nth(0)->scanAsInt() ;
	 } else if (label->equal(SC_WORDSTR(SenseBody))) {
	    countSenseBody = args->nth(0)->scanAsInt() ;
	 } else {
	    ITK_WRN("unknown sense_body info: " << *label
		    << " (rest_slot=" << *args
		    << ", rest=" << *infolist << ")") ;
	 } 
      }
      return True ;
   } ;
} ;

