// -*- Mode:C++ -*-
//Header:
//File: estimatePos.h
//Title: estimate position
//Author: NODA, Itsuki
//Date: 2001/03/05
//

//ModifyHistory:
// 2001/03/05: Start to create this file
//EndModifyHistory:

#ifndef _SPlayer_estimatePos_h_
#define _SPlayer_estimatePos_h_
////////////////////////////////////////////////////////////////////////

#include "BasePlayer.h"

namespace Soccer {
   
   /*--------------------*/
   /**
    *
    */

   inline void orientationAbs2Team(Vec& pos, Side side) {
      if(isRight(side)) { pos.x = -pos.x ; pos.y = -pos.y ; } 
   } 
      
   /*--------------------*/
   /**
    *
    */

   inline void orientationAbs2Team(PosDir& posdir, const Side side) {
      if(isRight(side)) { 
	 posdir.pos.x = -posdir.pos.x ; posdir.pos.y = -posdir.pos.y ; 
	 posdir.hdir += ((posdir.hdir > 0.0) ? -180.0 : 180.0) ;
	 posdir.bdir += ((posdir.bdir > 0.0) ? -180.0 : 180.0) ;
      } 
   }
   
   /*--------------------*/
   /**
    *
    */

   inline void orientationAbs2Team(PosDir& posdir, Vec& vel, 
				   const Side side) {
      if(isRight(side)) {
	 posdir.pos.x = -posdir.pos.x ; posdir.pos.y = -posdir.pos.y ; 
	 posdir.hdir += ((posdir.hdir > 0.0) ? -180.0 : 180.0) ;
	 posdir.bdir += ((posdir.bdir > 0.0) ? -180.0 : 180.0) ;
	 vel.x = -vel.x ; vel.y = -vel.y ; 
      } 
   }

   /*--------------------*/
   /**
    *
    */

   Bool estimatePosDirVelAbs1(PosDir& posdir, Vec& vel,
			      Bool& outOfFieldP,
			      const SeeInfo& sinfo) ;

   /*--------------------*/
   /**
    *
    */

   Bool estimatePosDirVelTeam1(PosDir& posdir, Vec& vel,
			       Bool& outOfFieldP,
			       const SeeInfo& sinfo, 
			       const Side side) ;
                
   /*--------------------*/
   /**
    *
    */

   Bool estimatePosDirVelAbs2(PosDir& posdir, Flt& posConf,
			      Vec& vel, Flt& velConf,
			      Bool& outOfFieldP,
			      const SeeInfo& sinfo) ;

   /*--------------------*/
   /**
    *
    */

   Bool estimatePosDirVelTeam2(PosDir& posdir, Flt& posConf,
			       Vec& vel, Flt& velConf,
			       Bool& outOfFieldP,
			       const SeeInfo& sinfo, 
			       const Side side) ;

   /*--------------------*/
   /**
    *
    */

   Bool estimatePosDirVelAbs3(PosDir& posdir, Flt& posConf,
			      Vec& vel, Flt& velConf,
			      Bool& outOfFieldP,
			      const SeeInfo& sinfo) ;

   /*--------------------*/
   /**
    *
    */

   Bool estimatePosDirVelTeam3(PosDir& posdir, Flt& posConf,
			       Vec& vel, Flt& velConf,
			       Bool& outOfFieldP,
			       const SeeInfo& sinfo, 
			       const Side side) ;

   /*--------------------*/
   /**
    *
    */

   Bool estimatePosDirVelTeam4(PosDir& posdir, Flt& posConf,
			       Bool& outOfFieldP,
			       const SeeInfo& sinf, const Side side) ;

}

////////////////////////////////////////////////////////////////////////
#endif
