// -*- Mode:C++ -*-
//Header:
//File: genTraj.cc
//Title: SPlayer
//Author: NODA, Itsuki
//Date: 2001/03/22
//

//ModifyHistory:
// 2001/03/22: Start to create this file
//EndModifyHistory:


#include "SimplePlayer.h"

using namespace Soccer ;
using namespace Itk ;

//======================================================================
// parameters

class Param {
   public:
      SString logfile ;
      Int loopMax ;
} ;

Param MyParam = {"foo.trj",
		 10000} ;

//======================================================================
// GenTrajPlayer2 class

class TestSenseBody : public SimplePlayer {
   public:
      virtual Bool analyzeSensorSenseBody() ;
} ;

Bool TestSenseBody::analyzeSensorSenseBody() {
   Bool r = 
      SimplePlayer::analyzeSensorSenseBody() ;
   ITK_DBG(btime()) ;
   return r ;
} ;
   

//======================================================================
// main loop

Bool mainloop(Param & param) {
   ITK_DBG(TimeVal::now()) ;
   for(Int i = 0 ; i < 1000 ; i++) 
      sleep(0,1) ;
   ITK_DBG(TimeVal::now()) ;
   exit(0) ;
   
   TestSenseBody player ;

   player.init() ;
   player.forkSensor() ;

   player.move(-5,0) ;
   player.turn(180);

   sleep(1,0) ;
   TimeVal next ; next.update() ;
   TimeVal tic(0,5) ;
   while(True) {
      player.sendSenseBody() ;
      next += tic ;
      sleepUntil(next) ;
   } 

   return True ;
}

//======================================================================
// getOpt

Bool getOpt(int & argc, char ** & argv, Param & param) {
   //----------------------------------------
   OptArg optlist[] = {

      {"logfile",	OptArg::SStringVal,	&(param.logfile),	0,
       "-logfile LOGFILENAME"},

      {"loopMax",	OptArg::IntVal,		&(param.loopMax),	0,
       "-loopMax LOOPMAX"},
   
      {ITK_NULLPTR}} ;
   //----------------------------------------
   
   myGetOpt(optlist, argc, argv) ;

   return True ;
}

//======================================================================
// main

int main(int argc, char** argv) {
   getOpt(argc,argv,MyParam) ;

   mainloop(MyParam) ;

   return 0 ;
} ;




	 


